package com.ningdatech.pmapi.meeting.entity.dto;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.NotEmpty;
import java.util.List;

/**
 * <p>
 * 专家邀请回避规则
 * </p>
 *
 * @author WendyYang
 * @since 10:22 2022/7/26
 */
@Data
@ApiModel("回避信息")
public class AvoidRuleDTO {

    @ApiModelProperty("回避单位")
    @NotEmpty(message = "回避单位不能为空", groups = {AbstractInviteRule.RuleSave.class})
    private List<String> avoidUnitIdList;

    @ApiModelProperty("回避条线")
    @NotEmpty(message = "回避条线不能为空", groups = {AbstractInviteRule.RuleSave.class})
    private List<String> avoidOrgIdList;

    @ApiModelProperty("每周邀请次数")
    private Integer weekInviteCount;

    @ApiModelProperty("回避专家")
    @NotEmpty(message = "回避专家不能为空", groups = {AbstractInviteRule.RuleSave.class})
    private List<Long> expertIds;

}
