package com.ningdatech.pmapi.performance.controller;

import com.ningdatech.basic.model.PageVo;
import com.ningdatech.pmapi.performance.manage.OrgSelfAppraisalManage;
import com.ningdatech.pmapi.performance.model.req.PerformanceAppraisalListReq;
import com.ningdatech.pmapi.performance.model.vo.PerformanceAppraisalProjectVO;
import com.ningdatech.pmapi.performance.model.vo.PerformanceAppraisalVO;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.RequiredArgsConstructor;
import org.springframework.web.bind.annotation.*;

/**
 * @Classname OrgSelfAppraisalController
 * @Description
 * @Date 2023/6/25 14:16
 * @Author PoffyZhang
 */
@RestController
@RequiredArgsConstructor
@Api(tags = "绩效评价-单位自评")
@RequestMapping("/api/v1/self-appraisal")
public class OrgSelfAppraisalController {

    private final OrgSelfAppraisalManage selfAppraisalManage;

    @GetMapping("/list")
    @ApiOperation("当前用户的绩效评价计划列表")
    public PageVo<PerformanceAppraisalVO> list(PerformanceAppraisalListReq req) {
        return selfAppraisalManage.list(req);
    }

    @GetMapping("/pending-list/{planId}")
    @ApiOperation("当前绩效评价待自评列表")
    public PageVo<PerformanceAppraisalProjectVO> pendingList(@PathVariable Long planId, PerformanceAppraisalListReq req) {
        return selfAppraisalManage.pendingList(planId,req);
    }

    @GetMapping("/appraisaled-list/{planId}")
    @ApiOperation("当前绩效评价已自评列表")
    public PageVo<PerformanceAppraisalProjectVO> appraisaledList(@PathVariable Long planId,PerformanceAppraisalListReq req) {
        return selfAppraisalManage.appraisaledList(planId);
    }
}
