package com.ningdatech.pmapi.performance.model.vo;

import com.ningdatech.pmapi.user.security.auth.model.UserFullInfoDTO;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.time.LocalDateTime;
import java.util.List;

/**
 * @Classname PerformanceAppraisalProjectGroupVO
 * @Description 绩效评价和项目分组
 * @Date 2023/6/19 14:02
 * @Author PoffyZhang
 */
@Data
@ApiModel(value = "绩效评价项目分组", description = "绩效评价项目分组")
public class PerformanceAppraisalProjectGroupVO implements Serializable {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty("主键")
    private Long id;

    private LocalDateTime createOn;
    private LocalDateTime updateOn;
    private String createBy;
    private String updateBy;

    @ApiModelProperty("名称")
    private String name;

    @ApiModelProperty("计划id")
    private Long appraisalId;

    @ApiModelProperty("分组内的所有项目")
    private List<PerformanceAppraisalProjectVO> projects;

    @ApiModelProperty("复评人员")
    private List<UserFullInfoDTO> reAppraisalUsers;

    @ApiModelProperty("核查人员")
    private List<UserFullInfoDTO> verificationUsers;
}
