package com.ningdatech.pmapi.performance.model.vo;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.time.LocalDateTime;
import java.util.List;

/**
 * @Classname PerformanceAppraisal
 * @Description 绩效评价对象
 * @Date 2023/6/19 14:02
 * @Author PoffyZhang
 */
@Data
@ApiModel(value = "绩效评价对象", description = "绩效评价对象")
public class PerformanceAppraisalVO implements Serializable {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty("主键")
    private Long id;

    private LocalDateTime createOn;
    private LocalDateTime updateOn;
    private String createBy;
    private String updateBy;

    @ApiModelProperty("计划名称")
    private String name;

    @ApiModelProperty("自评开始时间")
    private LocalDateTime selfAppraisalStart;

    @ApiModelProperty("自评结束时间")
    private LocalDateTime selfAppraisalEnd;

    @ApiModelProperty("复评开始时间")
    private LocalDateTime reAppraisalStart;

    @ApiModelProperty("复评结束时间")
    private LocalDateTime reAppraisalEnd;

    @ApiModelProperty("核查开始时间")
    private LocalDateTime verificationStart;

    @ApiModelProperty("核查结束时间")
    private LocalDateTime verificationEnd;

    @ApiModelProperty("评价目标 1项目 2应用 可多选 1,2")
    private String target;

    @ApiModelProperty("评价项目列表")
    private List<PerformanceAppraisalProjectVO> projects;

    @ApiModelProperty("评价应用列表")
    private List<PerformanceAppraisalApplicationVO> applications;
}
