package com.ningdatech.pmapi.performance.model.vo;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.util.List;

/**
 * @Classname PerformanceIndicatorProjectTemplateDetail
 * @Description 绩效评价考核项目指标模板
 * @Date 2023/6/19 14:02
 * @Author PoffyZhang
 */
@Data
@ApiModel(value = "绩效评价考核项目指标模板详情保存树", description = "绩效评价考核项目指标模板详情保存树")
public class ProjectTemplateDetailVO implements Serializable {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty("关联模板ID")
    private Long templateId;

    @ApiModelProperty("指标名称")
    private String name;

    @ApiModelProperty("指标类型 0阶段 1一级指标 2二级指标 3三级指标")
    private Integer type;

    @ApiModelProperty("父级指标id")
    private Long parentId;

    @ApiModelProperty("分数 3级指标才有")
    private Integer score;

    @ApiModelProperty("分数细则 3级指标才有")
    private String scoreRubric;

    @ApiModelProperty("评分pdf")
    private String pdf;

    @ApiModelProperty("阶段id")
    private Long stageId;

    @ApiModelProperty("子指标")
    private List<ProjectTemplateDetailVO> children;
}
