package com.ningdatech.pmapi.projectdeclared.model.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import java.math.BigDecimal;
import java.time.LocalDate;
import java.time.LocalDateTime;

/**
 * @Classname Purchase
 * @Description
 * @Date 2023/5/29 10:00
 * @Author PoffyZhang
 */
@TableName("nd_purchase")
@ApiModel(value = "采购对象", description = "采购对象")
@Data
@AllArgsConstructor
@NoArgsConstructor
public class Purchase {

    @TableId(type = IdType.AUTO)
    @ApiModelProperty("id")
    private Long id;

    @ApiModelProperty("项目ID")
    private Long projectId;

    @ApiModelProperty("创建时间")
    private LocalDateTime createOn;

    @ApiModelProperty("修改时间")
    private LocalDateTime updateOn;

    @ApiModelProperty("创建人 工号")
    private String createBy;

    @ApiModelProperty("修改人 工号")
    private String updateBy;

    @ApiModelProperty("供应商")
    private String supplier;

    @ApiModelProperty("供应商联系人")
    private String supplierContact;

    @ApiModelProperty("供应商联系方式")
    private String supplierContactInfo;

    @ApiModelProperty("采购方式 1公开招标 2自行采购")
    private Integer purchaseMethod;

    @ApiModelProperty("成交金额")
    private BigDecimal transactionAmount;

    @ApiModelProperty("成交时间")
    private LocalDateTime transactionTime;

    @ApiModelProperty("代理机构")
    private String agency;

    @ApiModelProperty("投标文件")
    private String biddingDoc;

    @ApiModelProperty("招标文件")
    private String bidDoc;

    @ApiModelProperty("中标通知书")
    private String acceptanceLetter;

}
