package com.ningdatech.pmapi.projectlib.model.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import java.io.Serializable;
import java.time.LocalDateTime;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/**
 * <p>
 * 项目延期申请记录表
 * </p>
 *
 * @author CMM
 * @since 2023-06-15
 */
@Data
@TableName("nd_project_delay_apply")
@ApiModel(value = "NdProjectDelayApply对象", description = "项目延期申请记录表")
public class ProjectDelayApply implements Serializable {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty("主键")
    @TableId(type = IdType.AUTO)
    private Long id;

    @ApiModelProperty("项目ID")
    private Long projectId;

    @ApiModelProperty("延期时间(几个月)")
    private Integer delayTime;

    @ApiModelProperty("延期申请佐证材料")
    private String delayApplyFile;

    @ApiModelProperty("延期申请理由")
    private String delayApplyReason;

    @ApiModelProperty("创建人")
    private Long createBy;

    @ApiModelProperty("创建时间")
    private LocalDateTime createOn;

    @ApiModelProperty("更新人")
    private Long updateBy;

    @ApiModelProperty("更新时间")
    private LocalDateTime updateOn;

    @ApiModelProperty("延期申请实例ID")
    private String instanceId;
}
