package com.ningdatech.pmapi.sys.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.ningdatech.pmapi.sys.model.entity.UserRole;

import java.util.List;

/**
 * <p>
 * 业务接口
 * 角色分配
 * 账号角色绑定
 * </p>
 *
 * @author PoffyZhang
 */
public interface IUserRoleService extends IService<UserRole> {
    /**
     * 初始化超级管理员角色 权限
     *
     * @param userId 用户id
     * @return 是否正确
     */
    boolean initAdmin(Long userId);

    /**
     * 查询角色关联的用户ID
     *
     * @param roleId 角色ID
     * @return 用户ID集合
     * @author WendyYang
     **/
    List<Long> listUserIdByRoleId(Long roleId);


}
