package com.ningdatech.pmapi.todocenter.model.vo;


import com.wflow.workflow.bean.process.enums.NodeTypeEnum;
import com.wflow.workflow.bean.vo.ProcessProgressVo;

import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * 流程进展详情实体
 *
 * @author CMM
 * @since 2023/01/30 17:21
 */
@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
public class ProcessProgressDetailVo {

    /**
     * 流程处理详情
     */
    private ProcessProgressVo processProgressVo;
    /**
     * 流程状态
     */
    private String status;
    /**
     * 项目ID
     */
    private Long projectId;

    /**
     * 能否撤回
     */
    private Boolean canWithdraw = Boolean.FALSE;

    /**
     * 能否通过
     */
    private Boolean canPass = Boolean.FALSE;

    /**
     * 能否盖章
     */
    private Boolean canSeal = Boolean.FALSE;

    /**
     * 能否驳回
     */
    private Boolean canReject = Boolean.FALSE;

    /**
     * 当前审批人 是不是流程配置里的 上级条线主管
     */
    private Boolean isHighLine = Boolean.FALSE;
}
